#include <bits/stdc++.h>
using namespace std;
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
long long q,n,x,y,ukupno,maks=0;
cin>>n>>q;
long long a[n+1];
long long sume[q+1];
for(int i=1;i<=n;i++){
    cin>>a[i];
    maks=max(maks,a[i]);

}
//if(maks<2){
   /* for(int i=1;i<=n;i++){


}

    for(int i=0;i<q;i++){
        cin>>x>>y;
        int maks=max(x,y);
    int mini=min(x,y);
    for(int j=mini;j<=maks;j++){
        if(a[j]==0){
            sume[i]=0;
            break;
        }
        else sume[i]=1;






    }






}
for(int i=0;i<q;i++){
    cout<<sume[i]<<endl;
}
return 0;

}
else{
    */
for(int i=1;i<=q;i++){

    cin>>x>>y;
    int maks=max(x,y);
    int mini=min(x,y);
    for(int j=mini;j<maks;j++){
            if(j==mini){
                    ukupno=a[j]&a[j+1];
                    continue;

            }
        else{
            ukupno&= a[j+1];
            //cout<<j+1<<" OVO JE JOT";
        }


    }
    sume[i]=ukupno;
    ukupno=0;

}
for(int i=1;i<=q;i++){
    cout<<sume[i]<<endl;
}


return 0;
}